#!/bin/sh 
. /var/packages/CloudStation/target/scripts/CloudStationCommon
HOOK_DIR="/var/packages/CloudStation/target/hook"
PKG_INFO="${HOOK_DIR}/pkg-info"
SHARE_HOOK="${HOOK_DIR}/share-hook"

CheckIfVolChange()
{	
	if [ "x" = "x$ORIGIN_SHARE_PATH" ]; then
		# For create case
		return 0;
	fi
	
	# home can't be renamed
	if [ "x$ORIGIN_SHARE_PATH" = "x$SHARE_PATH" ]; then
		# vol not change
		return 0;
	fi
	
	return 1;
}

is_homes_check()
{
	if [ "x" = "x${ORIGIN_SHARE_NAME}" ]; then
		return 0;
	fi

	if [ "xhomes" != "x${ORIGIN_SHARE_NAME}" ]; then
		return 0;
	fi

	return 1;
}

case $1 in
	# print package info
	--name|--pkg-ver|--vendor)
		${PKG_INFO} $1
	;;

	# print SDK module version
	--sdk-mod-ver)
		${SHARE_HOOK} --sdk-mod-ver
	;;

	# execute pre hook
	--pre)
		# handle home vol changed here
		is_homes_check;
		if [ 1 -eq $? ]; then
			PackageEnableGet;
			if [ 0 -eq $? ]; then
				exit 0;
			fi

			CheckIfVolChange;
			if [ 0 -eq $? ]; then
				exit 0;
			fi
			
			# stop all daemon
			${CSTN_START_SCRIPT} stop > /dev/null 2>&1;
		else
			${SHARE_HOOK} --pre-set
		fi
	;;

	# execute post hook
	--post)
		is_homes_check;
		if [ 1 -eq $? ]; then
	        PackageEnableGet;
        	if [ 0 -eq $? ]; then
				exit 0;
			fi

			CheckIfVolChange;
			if [ 0 -eq $? ]; then
				exit 0;
			fi
			
			if [ "0" != "$RESULT" ]; then
				logger -p 0 "$SHARE_SET_ACT" "Try to start cstn for bad result..."
				${CSTN_START_SCRIPT} start > /dev/null 2>&1;
				exit 0;
			fi
			
			# just start the daemon, repo is independent with home now
			${CSTN_START_SCRIPT} start > /dev/null 2>&1;

		else
			${SHARE_HOOK} --post-set
		fi
	;;

	*)
	;;
esac
